
/**
 * Write a description of class Calculator here.
 *
 * @author (your name)
 * @version (a version number or a date)
 */
public class Calculator {
    /*private Display display;
    private Console console;
    private CoreFeatures core;
    private ScientificFeatures sci;
    private BonusFeatures bonus;
    private CustomFeatures custom;
     */
    public Calculator() {
        /*display = new Display();
        console = new Console();
        core = new CoreFeatures();
         */
    }

    public void run() {

        Display display = new Display();
        CoreFeatures core = new CoreFeatures();
        ScientificFeatures sci = new ScientificFeatures();
        BonusFeatures bonus = new BonusFeatures();
        CustomFeatures custom = new CustomFeatures();
        boolean isRunning = true;
        StringBuilder command = new StringBuilder();
        double val;
        while (isRunning) {
            //always show 0 at start and then ask for value and print value
            command.setLength(0);
            Console.println("" + display.getValue());
            
            if (display.getValue() == 0) {
                try {
                    display.setValue(Console.getDoubleInput());
                    Console.println("" + display.getValue());
                } catch (Exception e) {
                    Console.println("Re-enter command to use 0");
                    Console.println("" + display.getValue());
                }
            }
            command.append(Console.getStringInput());
            val = display.getValue();
            switch (command.toString().toLowerCase()) {
                //core
                case "add": display.setValue(core.add(val));         
                break;
                case "subtract": display.setValue(core.subtract(val));
                break;
                case "multiply": display.setValue(core.multiply(val));
                break;
                case "square": display.setValue(core.square(val));
                break;
                case "divide": display.setValue(core.divide(val));
                break;
                case "sqrt": display.setValue(core.sqrt(val));
                break;
                case "exp": display.setValue(core.exp(val));
                break;
                case "inverse": display.setValue(core.invert(val));
                break;
                case "-": display.setValue(core.flip(val));
                break;
                
                //scientific
                case "switchdisplay": display.setValue(sci.switchDisplayMode(val));
                break;
                case "keydisplay" : display.setValue(sci.keyDisplayMode(val));
                break;
                case "m+": display.setMemory(display.getMemory() + val);
                break;
                case "mc": display.setMemory(0);
                break;
                case "mrc": display.setValue(display.getMemory());
                break;
                case "sin": display.setValue(sci.sin(val));
                break;
                case "cos": display.setValue(sci.cos(val));
                break;
                case "tan": display.setValue(sci.tan(val));
                break;
                case "invsin": display.setValue(sci.invSin(val));
                break;
                case "invcos": display.setValue(sci.invCos(val));
                break;
                case "invtan": display.setValue(sci.invTan(val));
                break;
                case "switchunits": sci.switchUnits();
                break;
                case "keyunits" : sci.keyUnits();
                break;
                
                //bonus
                case "!": display.setValue(bonus.factorial(val));
                break;
                case "log": display.setValue(bonus.log(val));
                break;
                case "invlog": display.setValue(bonus.inverseLog(val));
                break;
                case "ln": display.setValue(bonus.naturalLog(val));
                break;
                case "invln": display.setValue(bonus.inverseNaturalLog(val));
                break;
                
                //custom
                case "cuberoot": display.setValue(custom.cubeRoot(val));
                break;
                case "root": display.setValue(custom.root(val));
                break;
                
                //other
                case "clear": display.setValue(0);
                break;
                case "exit": Console.println("Thanks for using the calculator!");
                isRunning = false;
                break;
                default: Console.println("Not a valid command");
                break;
            }
        }
    }
}
