
/**
 * Write a description of class ScientificFeatures here.
 *
 * @author (your name)
 * @version (a version number or a date)
 */
public class ScientificFeatures {

    private enum displayMode { DECIMAL, BINARY, OCTAL, HEXADECIMAL };
    displayMode currentMode;
    boolean inDegrees;

    public ScientificFeatures(){
        currentMode = displayMode.DECIMAL;
        inDegrees = false;
    }

    public double switchDisplayMode(double x) {
        switch (currentMode) {
            case DECIMAL :
            System.out.println("Binary format: " + Integer.toBinaryString((int) x));
            currentMode = displayMode.BINARY;
            break;
            case BINARY :
            System.out.println("Octal format: " + Integer.toOctalString((int) x));
            currentMode = displayMode.OCTAL;
            break;
            case OCTAL :
            System.out.println("Hexadecimal format: " + Double.toHexString(x));
            currentMode = displayMode.HEXADECIMAL;
            break;
            case HEXADECIMAL :
            System.out.println("You are in decimal format");
            currentMode = displayMode.DECIMAL;
        } 
        return x;
    }

    public double keyDisplayMode(double x) {
        String mode = Console.getStringInput();
        switch (mode){
            case "binary" :
            System.out.println("Binary format: " + Integer.toBinaryString((int) x));
            currentMode = displayMode.BINARY;
            break;
            case "octal" :
            System.out.println("Octal format: " + Integer.toOctalString((int) x));
            currentMode = displayMode.OCTAL;
            break;
            case "hexadecimal" :
            System.out.println("Hexadecimal format: " + Double.toHexString(x));
            currentMode = displayMode.HEXADECIMAL;
            break;
            case "decimal" :
            System.out.println("This number is in decimal format:");
            currentMode = displayMode.DECIMAL;
            break;
            case "exit" :
            return x;
            default :
            System.out.println("Invalid. Enter binary, octal, hexadecimal, or decimal");
            this.keyDisplayMode(x);
        } 
        return x;
    }

    public double sin(double x) {
        if (inDegrees) {
            return Math.sin(Math.toRadians(x));
        } else {
            return Math.sin(x);
        }
    }

    public double cos(double x) {
        if (inDegrees) {
            return Math.cos(Math.toRadians(x));
        } else {
            return Math.cos(x);
        }
    }

    public double tan(double x) {
        if (inDegrees){
            return Math.tan(Math.toRadians(x));
        } else {
            return Math.tan(x);
        }
    }

    public double invSin(double x) {
        
        if (inDegrees) {
            return 1 / Math.sin(Math.toRadians(x));
        } else {
            return 1 / Math.sin(x);
        }
    }

    public double invCos(double x) {
        if (inDegrees) {
            return 1 / Math.cos(Math.toRadians(x));
        } else {
            return 1 / Math.cos(x);
        }
    }

    public double invTan(double x) {
        if (inDegrees){
            return 1 / Math.tan(Math.toRadians(x));
        } else {
            return 1 / Math.tan(x);
        }
    }

    public void switchUnits() {
        if (inDegrees) {
            inDegrees = false;
            System.out.println("You are now in radians units for trig functions");
        } else {
            inDegrees = true;
            System.out.println("You are now in degrees units for trig functions");
        }
    }

    public void keyUnits() {
        String trigmode = Console.getStringInput();
        switch(trigmode.toLowerCase()){
            case "degrees" :
            System.out.println("You are now in degrees units for trig functions");
            inDegrees = true;
            break;
            case "radians" :
            System.out.println("You are now in radians units for trig functions");
            inDegrees = false;
            break;
            case "exit" :
            break;
            default :
            System.out.println("Invalid. Enter degrees or radians");
            this.keyUnits();
        }
    }
}
